# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GetSpotMarketPriceResult:
    """
    A collection of values returned by getSpotMarketPrice.
    """
    def __init__(__self__, facility=None, plan=None, price=None, id=None):
        if facility and not isinstance(facility, str):
            raise TypeError("Expected argument 'facility' to be a str")
        __self__.facility = facility
        if plan and not isinstance(plan, str):
            raise TypeError("Expected argument 'plan' to be a str")
        __self__.plan = plan
        if price and not isinstance(price, float):
            raise TypeError("Expected argument 'price' to be a float")
        __self__.price = price
        """
        Current spot market price for given plan in given facility.
        """
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """
class AwaitableGetSpotMarketPriceResult(GetSpotMarketPriceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSpotMarketPriceResult(
            facility=self.facility,
            plan=self.plan,
            price=self.price,
            id=self.id)

def get_spot_market_price(facility=None,plan=None,opts=None):
    """
    Use this data source to get Packet Spot Market Price.
    
    :param str facility: Name of the facility.
    :param str plan: Name of the plan.

    > This content is derived from https://github.com/terraform-providers/terraform-provider-packet/blob/master/website/docs/d/spot_market_price.html.markdown.
    """
    __args__ = dict()

    __args__['facility'] = facility
    __args__['plan'] = plan
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('packet:index/getSpotMarketPrice:getSpotMarketPrice', __args__, opts=opts).value

    return AwaitableGetSpotMarketPriceResult(
        facility=__ret__.get('facility'),
        plan=__ret__.get('plan'),
        price=__ret__.get('price'),
        id=__ret__.get('id'))
