# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class Vlan(pulumi.CustomResource):
    description: pulumi.Output[str]
    """
    Description string
    """
    facility: pulumi.Output[str]
    """
    Facility where to create the VLAN
    """
    project_id: pulumi.Output[str]
    """
    ID of parent project
    """
    vxlan: pulumi.Output[float]
    """
    VXLAN segment ID
    """
    def __init__(__self__, resource_name, opts=None, description=None, facility=None, project_id=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a resource to allow users to manage Virtual Networks in their projects.
        
        To learn more about Layer 2 networking in Packet, refer to
        * https://support.packet.com/kb/articles/layer-2-configurations
        * https://support.packet.com/kb/articles/layer-2-overview
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description string
        :param pulumi.Input[str] facility: Facility where to create the VLAN
        :param pulumi.Input[str] project_id: ID of parent project

        > This content is derived from https://github.com/terraform-providers/terraform-provider-packet/blob/master/website/docs/r/vlan.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['description'] = description
            if facility is None:
                raise TypeError("Missing required property 'facility'")
            __props__['facility'] = facility
            if project_id is None:
                raise TypeError("Missing required property 'project_id'")
            __props__['project_id'] = project_id
            __props__['vxlan'] = None
        super(Vlan, __self__).__init__(
            'packet:index/vlan:Vlan',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, description=None, facility=None, project_id=None, vxlan=None):
        """
        Get an existing Vlan resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description string
        :param pulumi.Input[str] facility: Facility where to create the VLAN
        :param pulumi.Input[str] project_id: ID of parent project
        :param pulumi.Input[float] vxlan: VXLAN segment ID

        > This content is derived from https://github.com/terraform-providers/terraform-provider-packet/blob/master/website/docs/r/vlan.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["description"] = description
        __props__["facility"] = facility
        __props__["project_id"] = project_id
        __props__["vxlan"] = vxlan
        return Vlan(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

